<template>
  <el-form ref="form" :model="form" :rules="rules">
    <ele-pro-table
      ref="table"
      :needPage="false"
      :columns="columns"
      :toolkit="[]"
      max-height="500px"
      :datasource="form.datasource"
      cache-key="systemRoleTable17"
      class="time-form"
    >
      <!-- 表头工具栏 -->
      <template v-slot:toolbar>
        <div class="headbox">
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="handlAdd"
          >
            新增
          </el-button>
        </div>
      </template>
      <template v-slot:technicalDrawings="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.technicalDrawings'"
        >
          <fileMain v-model="row.technicalDrawings" type="view"></fileMain>
          <!--          <div v-if="row.technicalDrawings && row.technicalDrawings?.length">-->
          <!--            <el-link-->
          <!--              v-for="link in row.technicalDrawings"-->
          <!--              :key="link.id"-->
          <!--              type="primary"-->
          <!--              :underline="false"-->
          <!--              @click="downloadFile(link)"-->
          <!--            >-->
          <!--              {{ link.name }}-->
          <!--            </el-link-->
          <!--            >-->
          <!--          </div>-->
        </el-form-item>
      </template>
      <template v-slot:remark="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.remark'"
        >
          <el-input
            clearable
            v-model="row.remark"
            type="textarea"
            placeholder="请输入"
          />
        </el-form-item>
      </template>
      <template v-slot:totalCount="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.totalCount'"
          :rules="[
            { required: true, message: '请输入数字', trigger: 'blur' },
            { validator: validateTotalCount(scope.row), trigger: 'blur' }
          ]"
        >
          <el-input
            v-model="scope.row.totalCount"
            @input="(val) => changeNum(val, scope.$index, scope.row)"
          ></el-input>
        </el-form-item>
      </template>
      <!-- :disabled="!outsourceSendCode"      -->
      <template v-slot:sendTotalWeight="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.sendTotalWeight'"
          :rules="[
            {
              required: [2, 3].includes(Number(sourceType)) && pricingWay == 2,
              message: '请输入数字',
              trigger: 'blur'
            }
          ]"
        >
          <el-input-number
            :controls="false"
            v-model="scope.row.sendTotalWeight"
            @blur="changeSendTotalWeight(scope.$index)"
            style="width: 60%; margin-right: 10px"
          >
          </el-input-number>
          <el-button
            size="small"
            type="primary"
            v-if="[2, 3].includes(Number(sourceType)) && outsourceSendCode"
            @click.native="(e) => handleOutBound(e, scope.row, scope.$index)"
            >选择
          </el-button>
        </el-form-item>
      </template>
      <template v-slot:receiveTotalWeight="scope">
        <el-form-item
          :prop="'datasource.' + scope.$index + '.receiveTotalWeight'"
        >
          <el-input-number
            :controls="false"
            v-model="scope.row.receiveTotalWeight"
            style="width: 100%"
          >
          </el-input-number>
        </el-form-item>
      </template>
      <template v-slot:increaseTotalWeight="scope">
        <el-form-item
          :prop="'datasource.' + scope.$index + '.increaseTotalWeight'"
        >
          <el-input-number
            :controls="false"
            v-model="scope.row.increaseTotalWeight"
            style="width: 100%"
          >
          </el-input-number>
        </el-form-item>
      </template>

      <template v-slot:warehouseId="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.warehouseId'"
          :rules="[{ required: true, message: '请选择仓库', trigger: 'blur' }]"
        >
          <el-select
            v-model="scope.row.warehouseId"
            placeholder="请选择"
            @change="warehouseChange(scope.$index, scope.row)"
          >
            <el-option
              v-for="item in warehouseList"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </template>
      <template v-slot:warehouseNum="scope">
        <el-form-item style="margin-bottom: 20px">
          {{ scope.row.warehouseNum }}
        </el-form-item>
      </template>
      <template v-slot:headerWarehouseId="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerTotalCount="{ column }">
        <span
          :class="{
            'is-required':
              [2, 3].includes(Number(sourceType)) && pricingWay == 2
          }"
          >{{ column.label }}</span
        >
      </template>

      <!-- 操作列 -->
      <template v-slot:action="scope">
        <el-popconfirm
          class="ele-action"
          title="确定要删除吗？"
          @confirm="remove(scope.$index)"
        >
          <template v-slot:reference>
            <el-link type="danger" :underline="false" icon="el-icon-delete">
              删除
            </el-link>
          </template>
        </el-popconfirm>
      </template>
    </ele-pro-table>
    <product-list
      ref="productListRef"
      :orderId="orderId"
      type="purchase"
      @changeParent="changeParent"
      :productType="productType"
    ></product-list>
    <!--出库详情-->
    <outbound-details-dialog
      v-if="outboundDetailsDialogFlag"
      ref="outboundDetailsDialogRef"
      :outboundDetailsDialogFlag.sync="outboundDetailsDialogFlag"
      @saveDate="saveDate"
    ></outbound-details-dialog>
  </el-form>
</template>
<script>
  import { numberReg } from 'ele-admin';
  import productList from '@/views/saleManage/saleOrder/invoice/components/product-list.vue';
  import dictMixins from '@/mixins/dictMixins';
  import { getWarehouseList } from '@/api/saleManage/saleorder';

  import store from '@/store';
  import { copyObj } from '@/utils/util';
  import { getFile } from '@/api/system/file';
  import outboundDetailsDialog from './outboundDetailsDialog.vue';
  import { getOutInBySourceBizNoAPI } from '@/api/saleManage/returnGoods';
  import fileMain from '@/components/addDoc/index.vue';

  export default {
    mixins: [dictMixins],
    props: {
      orderId: String,
      outsourceSendCode: String,
      pricingWay: [String, Number],
      sourceType: [String, Number],
      productType: ''
    },
    components: {
      fileMain,
      outboundDetailsDialog,
      productList
    },
    data() {
      const defaultForm = {
        key: null,
        endTime: '',
        isFirst: 0,
        name: '',
        startTime: '',
        workHour: '',
        technicalDrawings: []
        // warehouseCode:"",
        // warehouseId:'',
        // warehouseName:'',
      };
      return {
        discountTotalPrice: 0.0,
        allPrice: 0.0,
        outboundDetailsDialogFlag: false,
        curIndex: undefined,
        numberReg,
        defaultForm,
        warehouseList: [],
        form: {
          datasource: []
        },
        oldSendTotalWeightList: [],
        outboundInfo: {},
        rules: {},
        columns: [
          {
            width: 45,
            type: 'index',
            columnKey: 'index',
            align: 'center',
            fixed: 'left'
          },
          {
            width: 200,
            prop: 'productName',
            label: '名称',
            slot: 'productName',
            align: 'center'
          },
          {
            width: 120,
            prop: 'productCode',
            label: '编码',
            slot: 'productCode',
            align: 'center'
          },
          {
            width: 200,
            prop: 'productCategoryName',
            label: '类型',
            slot: 'productCategoryName',
            align: 'center'
          },
          {
            minWidth: 150,
            prop: 'taskName',
            label: '工序',
            slot: 'taskName',
            align: 'center'
          },
          {
            width: 110,
            prop: 'batchNo',
            label: '批次号',
            slot: 'batchNo',
            align: 'center'
          },
          {
            width: 160,
            prop: 'productBrand',
            label: '牌号',
            slot: 'productBrand',
            align: 'center'
          },
          {
            width: 120,
            prop: 'modelType',
            label: '型号',
            slot: 'modelType',
            align: 'center'
          },
          // {
          //   width: 120,
          //   prop: 'imgCode',
          //   align: 'center',
          //   label: '图号/件号',
          //   showOverflowTooltip: true
          // },
          {
            width: 120,
            prop: 'produceType',
            align: 'center',
            label: '属性类型',
            showOverflowTooltip: true,
            formatter: (row, column) => {
              return row.produceType && row.produceType.length
                ? row.produceType
                    .map((item) => this.getDictValue('生产类型', item + ''))
                    .join(',')
                : '';
            }
          },
          // {
          //   width: 120,
          //   prop: 'approvalNumber',
          //   align: 'center',
          //   label: '批准文号',
          //   showOverflowTooltip: true
          // },
          {
            width: 120,
            prop: 'packingSpecification',
            align: 'center',
            label: '包装规格',
            showOverflowTooltip: true
          },
          {
            width: 120,
            prop: 'supplierMark',
            label: '供应商代号',
            slot: 'supplierMark',
            align: 'center'
          },
          {
            width: 120,
            prop: 'specification',
            label: '规格',
            slot: 'specification',
            align: 'center'
          },
          {
            width: 200,
            prop: 'warehouseId',
            label: '仓库名称',
            slot: 'warehouseId',
            headerSlot: 'headerWarehouseId',
            align: 'center'
          },
          {
            width: 120,
            prop: 'totalCount',
            label: '收货数量',
            slot: 'totalCount',
            headerSlot: 'headerTotalCount',
            align: 'center'
          },
          {
            width: 120,
            prop: 'orderTotalCount',
            label: '采购总数',
            slot: 'orderTotalCount',
            align: 'center'
          },
          {
            width: 120,
            prop: 'receiveTotalCount',
            label: '已收货总数',
            // slot: 'receiveTotalCount',
            align: 'center'
          },
          {
            width: 80,
            prop: 'measuringUnit',
            label: '计量单位',
            slot: 'measuringUnit',
            align: 'center'
          },
          {
            width: 120,
            prop: 'singleWeight',
            label: '单重',
            slot: 'singleWeight',
            align: 'center'
          },
          {
            width: 200,
            prop: 'sendTotalWeight',
            label: '发货总重',
            slot: 'sendTotalWeight',
            align: 'center',
            headerSlot: 'headerTotalCount'
          },
          {
            width: 100,
            prop: 'receiveTotalWeight',
            label: '收货总重',
            slot: 'receiveTotalWeight',
            align: 'center'
          },
          {
            width: 100,
            prop: 'increaseTotalWeight',
            label: '增重重量',
            slot: 'increaseTotalWeight',
            align: 'center'
          },
          {
            width: 100,
            prop: 'weightUnit',
            label: '重量单位',
            slot: 'weightUnit',
            align: 'center'
          },
          {
            width: 160,
            prop: 'pricingWay',
            label: '计价方式',
            slot: 'pricingWay',
            align: 'center',
            formatter: (row, column) => {
              return row.pricingWay == 1 ? '按数量计费' : row.pricingWay == 2 ? '按重量计费':'';

            }
          },
          {
            width: 160,
            prop: 'singlePrice',
            label: '单价',
            slot: 'singlePrice',
            align: 'center'
          },
          {
            width: 120,
            prop: 'taxRate',
            label: '税率',
            formatter: (_row, _column, cellValue) => {
              return _row.taxRate
                ? _row.taxRate+'%'
                : '';
            },
            align: 'center'
          },
          {
            width: 160,
            prop: 'discountSinglePrice',
            label: '折后单价',
            slot: 'discountSinglePrice',
            align: 'center'
          },
          {
            width: 120,
            prop: 'totalPrice',
            label: '合计',
            slot: 'totalPrice',
            align: 'center'
          },
          {
            width: 120,
            prop: 'discountTotalPrice',
            label: '折后合计',
            slot: 'discountTotalPrice',
            align: 'center'
          },
          {
            prop: 'provenance',
            label: '产地',
            slot: 'provenance',
            align: 'center',
            minWidth: 200,
            showOverflowTooltip: true,
            formatter: (row, column) => {
              return row.provenance && row.provenance.length
                ? row.provenance
                    .map((item) => this.getDictValue('产地', item))
                    .join(',')
                : '';
            }
          },
          // {
          //   width: 80,
          //   prop: 'deliveryDays',
          //   label: '交期(天)',
          //   slot: 'deliveryDays',
          //   align: 'center'
          // },
          {
            width: 160,
            prop: 'deliveryDeadline',
            label: '交期截止日期',
            slot: 'deliveryDeadline',
            align: 'center'
          },
          {
            width: 200,
            prop: 'guaranteePeriod',
            label: '质保期',
            slot: 'guaranteePeriod',
            formatter: (_row, _column, cellValue) => {
              return (
                (_row.guaranteePeriod || '') + _row.guaranteePeriodUnitName
              );
            },
            align: 'center'
          },
          {
            width: 160,
            prop: 'guaranteePeriodDeadline',
            label: '质保截止日期',
            slot: 'guaranteePeriodDeadline',
            align: 'center'
          },
          {
            width: 130,
            prop: 'technicalAnswerName',
            label: '技术答疑人',
            slot: 'technicalAnswerName',
            align: 'center'
          },
          {
            width: 220,
            prop: 'technicalParams',
            label: '技术参数',
            slot: 'technicalParams',
            align: 'center'
          },
          {
            width: 240,
            prop: 'technicalDrawings',
            label: '技术图纸',
            slot: 'technicalDrawings',
            align: 'center'
          },
          {
            width: 220,
            prop: 'remark',
            label: '备注',
            slot: 'remark',
            align: 'center'
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 120,
            align: 'center',
            resizable: false,
            slot: 'action',
            fixed: 'right',
            showOverflowTooltip: true
          }
        ]
      };
    },
    created() {
      this.requestDict('产地');
      this.requestDict('生产类型');
      
      getWarehouseList().then((res) => {
        this.warehouseList = res;
      });
    },

    computed: {},
    methods: {
      downloadFile(file) {
        getFile({ objectName: file.storePath }, file.name);
      },
      async warehouseChange(index, row) {
        const data = this.warehouseList.find(
          (item) => item.id == row.warehouseId
        );
        // if (warehouseIds.length > 0 && warehouseIds.includes(row.warehouseId)) {
        //   row.warehouseId = '';
        //   return this.$message.error('同一个产品不能选择相同的仓库');
        // }
        this.form.datasource.forEach((item, i) => {
          if (row.productCode == item.productCode && !item.warehouseId) {
            this.$set(this.form.datasource[i], 'warehouseName', data.name);
            this.$set(this.form.datasource[i], 'warehouseCode', data.code);
            this.$set(this.form.datasource[i], 'warehouseId', data.id);
          }
        });
        this.$set(this.form.datasource[index], 'warehouseName', data.name);
        this.$set(this.form.datasource[index], 'warehouseCode', data.code);
        this.$set(this.form.datasource[index], 'warehouseId', data.id);
      },
      //修改发货总重
      changeSendTotalWeight(index) {
        this.curIndex = index;
        this.setIcreaseTotalWeight();
      },
      //出库单详情
      handleOutBound(e, rows, index) {
        this.curIndex = index;
        this.outboundDetailsDialogFlag = true;
        this.$nextTick(() => {
          let row = {
            sendNo: this.outsourceSendCode,
            productCode: rows.productCode
          };
          this.$refs.outboundDetailsDialogRef.init(row);
        });
      },
      //选择退货信息回调
      saveDate(data = []) {
        let totalWeight = data.reduce((num, row) => {
          num += Number(row.weight);
          return num;
        }, 0);
        this.$set(
          this.form.datasource[this.curIndex],
          'sendTotalWeight',
          totalWeight
        );
        this.setIcreaseTotalWeight();
      },
      //修改数量更新合计/总重
      changeNum(val, index, row) {
        this.curIndex = index;
        if (row.pricingWay == 2) {
          if (val != this.form.datasource[index].orderTotalCount) {
            this.$set(this.form.datasource[index], 'sendTotalWeight', '');
            this.$set(
              this.form.datasource[index],
              'receiveTotalWeight',
              Number(val) * Number(this.form.datasource[index].singleWeight)
            );
          } else {
            let find =
              this.oldSendTotalWeightList.find(
                (key) =>
                  key.productCode == this.form.datasource[index].productCode
              ) || {};
            this.$set(
              this.form.datasource[index],
              'sendTotalWeight',
              find.oldSendTotalWeight || ''
            );
            this.$set(
              this.form.datasource[index],
              'receiveTotalWeight',
              Number(val) * Number(this.form.datasource[index].singleWeight)
            );
          }
          this.setIcreaseTotalWeight();
          this.getWeightPrice();
        } else {
          this.$set(
            this.form.datasource[index],
            'totalPrice',
            (Number(this.form.datasource[index].singlePrice) * val).toFixed(2)
          );
          this.$set(
            this.form.datasource[index],
            'discountTotalPrice',
            (
              Number(this.form.datasource[index].discountSinglePrice) * val
            ).toFixed(2)
          );
          this.$set(
            this.form.datasource[index],
            'receiveTotalWeight',
            Number(this.form.datasource[index].totalCount) *
              Number(this.form.datasource[index].singleWeight)
          );
          this.$set(
            this.form.datasource[index],
            'increaseTotalWeight',
            Number(this.form.datasource[index].totalCount) *
              Number(this.form.datasource[index].singleWeight)
          );
        }
      },
      getWeightPrice() {
        if (this.form.datasource[this.curIndex]['pricingWay'] != 2) {
          reutrn;
        }
        let increaseTotalWeight =
          this.form.datasource[this.curIndex].increaseTotalWeight;
        let singlePrice = this.form.datasource[this.curIndex].singlePrice;
        let discountSinglePrice =
          this.form.datasource[this.curIndex].discountSinglePrice;
        this.$set(
          this.form.datasource[this.curIndex],
          'totalPrice',
          (Number(increaseTotalWeight) * Number(singlePrice)).toFixed(2)
        );
        this.$set(
          this.form.datasource[this.curIndex],
          'discountTotalPrice',
          (Number(discountSinglePrice) * Number(increaseTotalWeight)).toFixed(2)
        );
      },
      //设置增重总重
      setIcreaseTotalWeight() {
        let receiveTotalWeight = Number(
          this.form.datasource[this.curIndex].receiveTotalWeight
        );
        let sendTotalWeight = Number(
          this.form.datasource[this.curIndex].sendTotalWeight
        );
        this.$set(
          this.form.datasource[this.curIndex],
          'increaseTotalWeight',
          (receiveTotalWeight - sendTotalWeight).toFixed(2)
        );
        this.getWeightPrice();
        this.$refs.table.reload();
      },
      //选择产品回调
      changeParent(obj, idx) {
        obj.orderTotalCount = obj.orderTotalCount || obj.totalCount;
        obj.id = '';
        this.$set(
          this.form.datasource,
          this.form.datasource.length,
          copyObj(obj)
        );
        this.form.datasource.forEach((item, index) => {
            item.receiveTotalWeight =
              item.receiveTotalWeight ||
              Number(item.totalCount) * Number(item.singleWeight) ||
              0;
            if (this.outsourceSendCode) {
              item.increaseTotalWeight =
                Number(item.receiveTotalWeight) - Number(item.sendTotalWeight);
            } else {
              item.increaseTotalWeight =
                item.increaseTotalWeight || item.receiveTotalWeight || 0;
            }
            item.sendTotalWeight = item.sendTotalWeight || 0;
            item.pricingWay=item.pricingWay||this.pricingWay
            this.changeNum(item.totalCount, index,item);
            
          });
      },
      validateTotalCount(row) {
        let totalCount=Number(row.totalCount)
        if(row.receiveTotalCount){
          totalCount+=Number(row.receiveTotalCount)
        }
        return (rule, value, callback) => {
          if (isNaN(value) || Number(value) <= 0) {
            // this.$message.error('请输入大于0的数');
            callback(new Error('请输入大于0的数字'));
          } else if (totalCount> row.orderTotalCount) {
         
            // this.$message.warning('收货数量大于采购总数量');
            callback(new Error('收货数量大于采购总数量'));
          } else {
            callback();
          }
        };
      },
      getTotalCount(row) {
        let num = 0;
        this.form.datasource
          .filter((item) => item.productCode == row.productCode)
          .forEach((item) => {
            num += Number(item.totalCount);
          });
        return num;
      },
      // 返回列表数据
      getTableValue() {
        let comitDatasource = this.form.datasource;
        if (comitDatasource.length === 0) return [];
        comitDatasource.forEach(async (v) => {
          v.totalCount = Number(v.totalCount);
          v.technicalDrawings = Array.isArray(v.technicalDrawings)
            ? v.technicalDrawings
            : [];
        });
        return comitDatasource;
      },
      getPrice() {
        return [this.allPrice];
      },

      //修改回显
      async putTableValue(data = [], code) {
        this.$nextTick(() => {
          this.form.datasource = data;
          this.oldSendTotalWeightList = this.form.datasource.map((item) => {
            return {
              productCode: item.productCode,
              oldSendTotalWeight: item.sendTotalWeight
            };
          });
          this.form.datasource.forEach((item, index) => {
            item.receiveTotalWeight =
              item.receiveTotalWeight ||
              Number(item.totalCount) * Number(item.singleWeight) ||
              0;
            if (this.outsourceSendCode) {
              item.increaseTotalWeight =
                Number(item.receiveTotalWeight) - Number(item.sendTotalWeight);
            } else {
              item.increaseTotalWeight =
                item.increaseTotalWeight || item.receiveTotalWeight || 0;
            }
            item.sendTotalWeight = item.sendTotalWeight || 0;
            item.pricingWay=item.pricingWay||this.pricingWay
            this.changeNum(item.totalCount, index,item);
            
          });
          this.$refs.table.reload();
          this.$forceUpdate();
        });
      },

      remove(i) {
        this.form.datasource.splice(i, 1);
        this.setSort();
      },
      // 清空表格
      restTable() {
        this.form.datasource = [];
      },
      // 重新排序
      setSort() {
        this.form.datasource.forEach((n, index) => {
          n.key = index + 1;
        });
      },
      // 添加
      handlAdd() {
        if (!this.orderId) return this.$message.error('请先选择订单');
        this.$refs.productListRef.open(this.form.datasource);
      },

      validateForm(callback) {
        //开始表单校验
        this.$refs.form.validate((valid,obj) => {
          if (obj) {
            let messages = Object.keys(obj).map((key) => obj[key][0]);
            if (messages.length > 0) {
              this.$message.warning(messages[0].message);
            }
          }
          callback(valid);
        });
      }
    }
  };
</script>
<style lang="scss" scoped>
  .headbox {
    display: flex;
    justify-content: space-between;
    align-items: center;

    .amount {
      font-size: 14px;
      font-weight: bold;
      padding-right: 30px;
    }
  }

  .time-form .el-form-item {
    margin-bottom: 0 !important;
  }

  ::v-deep .period {
    display: flex;

    .borderleftnone {
      .el-input--medium .el-input__inner {
        border-top-right-radius: 0;
        border-bottom-right-radius: 0;
      }
    }

    .borderrightnone {
      .el-input--medium .el-input__inner {
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
      }
    }
  }

  ::v-deep .time-form tbody > tr:hover > td {
    background-color: transparent !important;
  }

  ::v-deep .time-form .el-table tr {
    background-color: #ffffff;
  }

  .pricebox {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    font-weight: bold;
  }
</style>
